    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.renderer.xyz;
    034
    035import java.awt.Color;
    036
    037/**
    038 * A source of {@code Color} values for an {@link XYZRenderer}.
    039 * <p>
    040 * Classes that implement this interface should also implement
    041 * {@code java.io.Serializable}, otherwise it will not be possible to
    042 * serialize and deserialize charts that use the non-serializable instance.
    043 */
    044public interface XYZColorSource {
    045
    046    /**
    047     * Returns the color for one item in the plot.
    048     *
    049     * @param series  the series index.
    050     * @param item  the item index.
    051     *
    052     * @return The color (never {@code null}).
    053     */
    054    Color getColor(int series, int item);
    055
    056    /**
    057     * Returns the color that represents the specified series.
    058     *
    059     * @param series  the series index.
    060     *
    061     * @return The color (never {@code null}).
    062     */
    063    Color getLegendColor(int series);
    064
    065    /**
    066     * Restyles the source using the specified colors.  Refer to the
    067     * implementing class to confirm the precise behaviour (typically all
    068     * existing color settings are cleared and the specified colors are
    069     * installed as the new defaults).
    070     *
    071     * @param colors  the colors.
    072     *
    073     * @since 1.2
    074     */
    075    void style(Color... colors);
    076}